'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authChanged = exports.authFailure = exports.authInit = exports.signOut = exports.signInWithGithub = exports.signInWithTwitter = exports.signInWithFacebook = exports.signInWithGoogle = exports.signInAnonymously = exports.signInWithEmailAndPassword = exports.createUserWithEmailAndPassword = undefined;

var _reduxActions = require('redux-actions');

var _types = require('./types');

var types = _interopRequireWildcard(_types);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var createUserWithEmailAndPassword = exports.createUserWithEmailAndPassword = (0, _reduxActions.createAction)(types.CREATE_USER_WITH_EMAIL_AND_PASSWORD);

var signInWithEmailAndPassword = exports.signInWithEmailAndPassword = (0, _reduxActions.createAction)(types.SIGNIN_WITH_EMAIL_AND_PASSWORD);
var signInAnonymously = exports.signInAnonymously = (0, _reduxActions.createAction)(types.SIGNIN_ANONYMOUSLY);
var signInWithGoogle = exports.signInWithGoogle = (0, _reduxActions.createAction)(types.SIGNIN_WITH_GOOGLE);
var signInWithFacebook = exports.signInWithFacebook = (0, _reduxActions.createAction)(types.SIGNIN_WITH_FACEBOOK);
var signInWithTwitter = exports.signInWithTwitter = (0, _reduxActions.createAction)(types.SIGNIN_WITH_TWITTER);
var signInWithGithub = exports.signInWithGithub = (0, _reduxActions.createAction)(types.SIGNIN_WITH_GITHUB);

var signOut = exports.signOut = (0, _reduxActions.createAction)(types.SIGNOUT);

var authInit = exports.authInit = (0, _reduxActions.createAction)(types.AUTH_INIT);
var authFailure = exports.authFailure = (0, _reduxActions.createAction)(types.AUTH_FAILURE);
var authChanged = exports.authChanged = (0, _reduxActions.createAction)(types.AUTH_CHANGED);

exports.default = {
  createUserWithEmailAndPassword: createUserWithEmailAndPassword,
  signInWithEmailAndPassword: signInWithEmailAndPassword,
  signInAnonymously: signInAnonymously,
  signInWithGoogle: signInWithGoogle,
  signInWithFacebook: signInWithFacebook,
  signInWithTwitter: signInWithTwitter,
  signInWithGithub: signInWithGithub,
  signOut: signOut,
  authInit: authInit,
  authFailure: authFailure,
  authChanged: authChanged
};