'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments[1];

  switch (action.type) {
    case _actions2.default.SIGNIN_WITH_EMAIL_AND_PASSWORD:
    case _actions2.default.SIGNIN_ANONYMOUSLY:
    case _actions2.default.SIGNIN_WITH_GOOGLE:
    case _actions2.default.SIGNIN_WITH_FACEBOOK:
    case _actions2.default.SIGNIN_WITH_TWITTER:
    case _actions2.default.SIGNIN_WITH_GITHUB:
    case _actions2.default.SIGNOUT:
      return (0, _extends3.default)({}, state, {
        loading: true,
        error: null
      });
    case _actions2.default.AUTH_FAILURE:
      return (0, _extends3.default)({}, state, {
        loading: false,
        error: action.payload
      });
    case _actions2.default.AUTH_CHANGED:
      return (0, _extends3.default)({}, state, {
        loading: false,
        authenticated: action.payload != null
      });
    case _actions2.default.AUTH_INIT:
      return (0, _extends3.default)({}, state, {
        options: action.payload
      });
    default:
      return state;
  }
};

var _actions = require('../actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var INITIAL_STATE = {
  options: {},
  loading: false,
  authenticated: false,
  error: null
};