'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FirebaseSagas = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _firebase = require('firebase');

var _firebase2 = _interopRequireDefault(_firebase);

var _authModule = require('./authModule');

var _authModule2 = _interopRequireDefault(_authModule);

var _dbModule = require('./dbModule');

var _dbModule2 = _interopRequireDefault(_dbModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @class FirebaseSagas
 * @classdesc
 * FirebaseSagas
 */
var FirebaseSagas = exports.FirebaseSagas = function () {
  function FirebaseSagas(app) {
    (0, _classCallCheck3.default)(this, FirebaseSagas);

    this.app = app;

    /**
     * See module database
     * @member FirebaseSagas#database
     * @see database
     */
    this.database = {
      once: _dbModule2.default.once.bind(this),
      push: _dbModule2.default.push.bind(this),
      update: _dbModule2.default.update.bind(this),
      set: _dbModule2.default.set.bind(this),
      remove: _dbModule2.default.remove.bind(this),
      on: _dbModule2.default.on.bind(this),
      createOnEventChannel: _dbModule2.default.createOnEventChannel.bind(this)
    };

    /**
     * See module auth
     * @member FirebaseSagas#auth
     * @see auth
     */
    this.auth = {
      syncUser: _authModule2.default.syncUser.bind(this),
      createOnAuthStateChangedChannel: _authModule2.default.createOnAuthStateChangedChannel.bind(this),
      signInWithEmailAndPassword: _authModule2.default.signInWithEmailAndPassword.bind(this),
      signInAnonymously: _authModule2.default.signInAnonymously.bind(this),
      signInWithCustomToken: _authModule2.default.signInWithCustomToken.bind(this),
      signInWithPopup: _authModule2.default.signInWithPopup.bind(this),
      signInWithGoogle: _authModule2.default.signInWithGoogle.bind(this),
      signInWithFacebook: _authModule2.default.signInWithFacebook.bind(this),
      signInWithTwitter: _authModule2.default.signInWithTwitter.bind(this),
      signInWithGithub: _authModule2.default.signInWithGithub.bind(this),
      signOut: _authModule2.default.signOut.bind(this),
      createUserWithEmailAndPassword: _authModule2.default.createUserWithEmailAndPassword.bind(this),
      currentUser: _authModule2.default.currentUser.bind(this)
    };
  }

  /**
   * Factory to generate FirebaseSagas by firebase-config
   */


  (0, _createClass3.default)(FirebaseSagas, null, [{
    key: 'createByConfig',
    value: function createByConfig(config) {
      var app = _firebase2.default.initializeApp(config);
      return new FirebaseSagas(app);
    }
  }]);
  return FirebaseSagas;
}();

/**
 * Creates a FirebaseSagas-Instance
 * @function
 * @param {object} config FireBase config
 * @return {FirebaseSagas} firebaseSagas
 * @example
 * import createFirebaseSagas from 'firebase-sagas':
 *
 * const config = {
 *   apiKey: 'YOUR_API_KEY',
 *   authDomain: 'YOUR_AUTH_DOMAIN',
 *   databaseURL: 'YOUR_DATABASE_URL',
 *   projectId: 'YOUR_PROJECT_ID',
 *   storageBucket: 'YOUR_STORAGE_BUCKET',
 *   messagingSenderId: 'YOUR_MESSAGING_SENDER_ID'
 * };
 *
 * const firebaseSagas = createFirebaseSagas(config);
 */


var createFirebaseSagas = function createFirebaseSagas(config) {
  return FirebaseSagas.createByConfig(config);
};

exports.default = createFirebaseSagas;